<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 3.3: Else-If</title>
<link href="sx6b.html" rev=precedes>
<link href="sx6d.html" rel=precedes>
<link href="sx6.html" rev=subdocument>
</head>
<body>
<H2>section 3.3: Else-If</H2>

pages 57-58
<p>Binary search is an extremely important algorithm,
but it turns out that it is subtle to get the implementation just right.
(It has been observed that
although
the first binary search was published in 1946,
the first published binary search without bugs did not appear until 1962.)
The basic idea is the same as the algorithm we all tend to use 
when we're asked to guess a number between 1 and 100:
``Is it between 1 and 50?
Yes?
Okay, is it between 25 and 50?
No?
Okay, is it between 1 and 12?
...
''
(Don't worry if you can't follow all of the details of the algorithm
or the code on page 58,
but do remember to be extremely careful
if you're ever asked to write a binary search routine.)
</p><hr>
<p>
Read sequentially:
<a href="sx6b.html" rev=precedes>prev</a>
<a href="sx6d.html" rel=precedes>next</a>
<a href="sx6.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
